#ifdef _WIN32
	#pragma warning(disable:4996)
	#include <tchar.h>
	#include <windows.h>
	#include <conio.h>
	#include <direct.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	#include <stdlib.h>
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <unistd.h>
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <string.h>
#include <iostream>
#include <iomanip>
using namespace std;

#include "Matica.h"
//---------------------------------------------------------------------------
//Konstruktor inicializuje prvky matice
TMatica::TMatica()
{
	PocetRiadkov = MAXPOCET;
	PocetStlpcov = MAXPOCET;
	for (unsigned i = 0; i<PocetRiadkov; i++)
		for (unsigned j = 0; j<PocetStlpcov; j++)
			Matica[i][j] = 0;
}
//---------------------------------------------------------------------------
TMatica::~TMatica()
{
}
//---------------------------------------------------------------------------
const TMatica operator+(const TMatica& LavaMatica, const TMatica& PravaMatica)
{
	TMatica VyslMatica;

	VyslMatica.PocetRiadkov = LavaMatica.PocetRiadkov;
	VyslMatica.PocetStlpcov = LavaMatica.PocetStlpcov;
	for (unsigned i = 0; i<LavaMatica.PocetRiadkov; i++)
		for (unsigned j = 0; j<LavaMatica.PocetStlpcov; j++)
			VyslMatica.Matica[i][j] = LavaMatica.Matica[i][j] 
			+ PravaMatica.Matica[i][j];
	return VyslMatica;
}
//---------------------------------------------------------------------------
const TMatica operator*(const TMatica& LavaMatica, const TMatica& PravaMatica)
{
	TMatica VyslMatica;
	my_class xx;
	unsigned i, j, k;
	float Suma;

	if (LavaMatica.PocetStlpcov != PravaMatica.PocetRiadkov) {
		cout << "\n  Matice sa nedaju nasobit!";
		xx.my_getch();
	}
	VyslMatica.PocetRiadkov = LavaMatica.PocetRiadkov;
	VyslMatica.PocetStlpcov = PravaMatica.PocetStlpcov;
	for (i = 0; i<LavaMatica.PocetRiadkov; i++)
		for (j = 0; j<PravaMatica.PocetStlpcov; j++) {
			Suma = 0;
			for (k = 0; k<LavaMatica.PocetStlpcov; k++)
				Suma += LavaMatica.Matica[i][k] * PravaMatica.Matica[k][j];
			VyslMatica.Matica[i][j] = Suma;
		}
	return VyslMatica;
}
//---------------------------------------------------------------------------
TMatica TMatica::UmocniMaticu(unsigned k)
{
	TMatica Y, PomMatica0, PomMatica;
	my_class xx;

	if (PocetStlpcov != PocetRiadkov) {
		cout << "\n  Matica sa neda umocnit!";
		xx.my_getch();
		exit(1);
	}
	Y.PocetRiadkov = Y.PocetStlpcov = PocetRiadkov;

	switch (k) {
	case 0:
		for (unsigned i = 0; i<PocetRiadkov; i++) {
			for (unsigned j = 0; j<PocetRiadkov; j++)
				Y.Matica[i][j] = 0;
			Y.Matica[i][i] = 1;
		}
		break;
	case 1:
		Y = *this;
		break;
	default:
		PomMatica0 = PomMatica = *this;
		k--;
		while (k--) {
			Y = PomMatica * PomMatica0;
			PomMatica = Y;
		}
	}

	return Y;
}
//---------------------------------------------------------------------------
istream& operator>>(istream& is, TMatica& X)
{
	my_class xx;

	is >> X.PocetRiadkov >> X.PocetStlpcov;
	if (is.fail()) {
		cout << "\n\n  Vstupny subor sa nepodarilo otvorit!\n";
		xx.my_getch();
		exit(1);
	}
	for (unsigned i = 0; i<X.PocetRiadkov; i++)
		for (unsigned j = 0; j<X.PocetStlpcov; j++)
			is >> X.Matica[i][j];
	return is;
}
//---------------------------------------------------------------------------
ostream& operator<<(ostream& os, TMatica& X)
{
	os.setf(ios::fixed, ios::floatfield);
	os.precision(2);
	for (unsigned i = 0; i<X.PocetRiadkov; i++) {
		os << "\n  ";
		for (unsigned j = 0; j<X.PocetStlpcov; j++)
			os << setw(8) << X.Matica[i][j];
	}
	os << "\n";
	return os;
}
//---------------------------------------------------------------------------
void my_class::my_getch() const
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
